"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AssignmentController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const platform_express_1 = require("@nestjs/platform-express");
const swagger_1 = require("@nestjs/swagger");
const assignment_schema_1 = require("../schemas/assignment.schema");
const assignment_service_1 = require("../services/assignment.service");
let AssignmentController = class AssignmentController {
    constructor(assignmentService) {
        this.assignmentService = assignmentService;
    }
    async create(assignmentFile, answerFile, assignment) {
        var _a, _b;
        try {
            if (assignmentFile) {
                assignment.assignmentFile = (_a = assignmentFile === null || assignmentFile === void 0 ? void 0 : assignmentFile.buffer) === null || _a === void 0 ? void 0 : _a.toString("base64");
            }
            if (answerFile) {
                assignment.answerFile = (_b = answerFile === null || answerFile === void 0 ? void 0 : answerFile.buffer) === null || _b === void 0 ? void 0 : _b.toString("base64");
            }
            return await this.assignmentService.create(assignment);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
    async edit(assignmentId, assignmentFile, answerFile, updatedAssignment) {
        var _a, _b;
        try {
            if (assignmentFile && !updatedAssignment.assignmentFile.startsWith("https")) {
                updatedAssignment.assignmentFile = (_a = assignmentFile === null || assignmentFile === void 0 ? void 0 : assignmentFile.buffer) === null || _a === void 0 ? void 0 : _a.toString("base64");
            }
            if (answerFile && !updatedAssignment.answerFile.startsWith("https")) {
                updatedAssignment.answerFile = (_b = answerFile === null || answerFile === void 0 ? void 0 : answerFile.buffer) === null || _b === void 0 ? void 0 : _b.toString("base64");
            }
            return await this.assignmentService.edit(assignmentId, updatedAssignment);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
    async getAll() {
        try {
            return await this.assignmentService.findAll();
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getById(assignmentId) {
        try {
            return await this.assignmentService.findById(assignmentId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.NOT_FOUND);
        }
    }
    async getByLessonId(lessonId) {
        try {
            return await this.assignmentService.findByLessonId(lessonId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async delete(assignmentId) {
        try {
            await this.assignmentService.delete(assignmentId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
};
__decorate([
    (0, common_1.Post)('create'),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)("assignmentFile")),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)("answerFile")),
    openapi.ApiResponse({ status: 201, type: require("../schemas/assignment.schema").Assignment }),
    __param(0, (0, common_1.UploadedFile)()),
    __param(1, (0, common_1.UploadedFile)()),
    __param(2, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, assignment_schema_1.Assignment]),
    __metadata("design:returntype", Promise)
], AssignmentController.prototype, "create", null);
__decorate([
    (0, common_1.Put)('edit/:id'),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)("assignmentFile")),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)("answerFile")),
    openapi.ApiResponse({ status: 200, type: require("../schemas/assignment.schema").Assignment }),
    __param(0, (0, common_1.Param)('id')),
    __param(1, (0, common_1.UploadedFile)()),
    __param(2, (0, common_1.UploadedFile)()),
    __param(3, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object, Object, assignment_schema_1.Assignment]),
    __metadata("design:returntype", Promise)
], AssignmentController.prototype, "edit", null);
__decorate([
    (0, common_1.Get)('get-all'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/assignment.schema").Assignment] }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AssignmentController.prototype, "getAll", null);
__decorate([
    (0, common_1.Get)('get-by-id/:id'),
    openapi.ApiResponse({ status: 200, type: require("../schemas/assignment.schema").Assignment }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], AssignmentController.prototype, "getById", null);
__decorate([
    (0, common_1.Get)('get-by-lesson/:lessonId'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/assignment.schema").Assignment] }),
    __param(0, (0, common_1.Param)('lessonId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], AssignmentController.prototype, "getByLessonId", null);
__decorate([
    (0, common_1.Delete)('delete/:id'),
    openapi.ApiResponse({ status: 200 }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], AssignmentController.prototype, "delete", null);
AssignmentController = __decorate([
    (0, swagger_1.ApiTags)("Assignments"),
    (0, common_1.Controller)('assignments'),
    __metadata("design:paramtypes", [assignment_service_1.AssignmentService])
], AssignmentController);
exports.AssignmentController = AssignmentController;
//# sourceMappingURL=assignment.controller.js.map