"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CourseProgressController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const courseProgress_schema_1 = require("../schemas/courseProgress.schema");
const courseProgress_service_1 = require("../services/courseProgress.service");
let CourseProgressController = class CourseProgressController {
    constructor(courseProgressService) {
        this.courseProgressService = courseProgressService;
    }
    async create(courseProgress) {
        try {
            return await this.courseProgressService.create(courseProgress);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
    async edit(courseProgressId, updatedCourseProgress) {
        try {
            return await this.courseProgressService.edit(courseProgressId, updatedCourseProgress);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
    async getById(courseProgressId) {
        try {
            return await this.courseProgressService.getById(courseProgressId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.NOT_FOUND);
        }
    }
    async getByStudentId(studentId) {
        try {
            return await this.courseProgressService.getByStudentId(studentId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getByCourseId(courseId) {
        try {
            return await this.courseProgressService.getByCourseId(courseId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getByLessonId(lessonId) {
        try {
            return await this.courseProgressService.getByLessonId(lessonId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async delete(courseProgressId) {
        try {
            return await this.courseProgressService.delete(courseProgressId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
};
__decorate([
    (0, common_1.Post)('create'),
    openapi.ApiResponse({ status: 201, type: require("../schemas/courseProgress.schema").CourseProgress }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [courseProgress_schema_1.CourseProgress]),
    __metadata("design:returntype", Promise)
], CourseProgressController.prototype, "create", null);
__decorate([
    (0, common_1.Put)('edit/:courseProgressId'),
    openapi.ApiResponse({ status: 200, type: require("../schemas/courseProgress.schema").CourseProgress }),
    __param(0, (0, common_1.Param)('courseProgressId')),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, courseProgress_schema_1.CourseProgress]),
    __metadata("design:returntype", Promise)
], CourseProgressController.prototype, "edit", null);
__decorate([
    (0, common_1.Get)(':courseProgressId'),
    openapi.ApiResponse({ status: 200, type: require("../schemas/courseProgress.schema").CourseProgress }),
    __param(0, (0, common_1.Param)('courseProgressId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], CourseProgressController.prototype, "getById", null);
__decorate([
    (0, common_1.Get)('get-by-student/:studentId'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/courseProgress.schema").CourseProgress] }),
    __param(0, (0, common_1.Param)('studentId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], CourseProgressController.prototype, "getByStudentId", null);
__decorate([
    (0, common_1.Get)('get-by-course/:courseId'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/courseProgress.schema").CourseProgress] }),
    __param(0, (0, common_1.Param)('courseId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], CourseProgressController.prototype, "getByCourseId", null);
__decorate([
    (0, common_1.Get)('get-by-lesson/:lessonId'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/courseProgress.schema").CourseProgress] }),
    __param(0, (0, common_1.Param)('lessonId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], CourseProgressController.prototype, "getByLessonId", null);
__decorate([
    (0, common_1.Delete)('delete/:courseProgressId'),
    openapi.ApiResponse({ status: 200 }),
    __param(0, (0, common_1.Param)('courseProgressId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], CourseProgressController.prototype, "delete", null);
CourseProgressController = __decorate([
    (0, swagger_1.ApiTags)("CourseProgress"),
    (0, common_1.Controller)('courseProgress'),
    __metadata("design:paramtypes", [courseProgress_service_1.CourseProgressService])
], CourseProgressController);
exports.CourseProgressController = CourseProgressController;
//# sourceMappingURL=courseProgress.controller.js.map