"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EnrollmentsController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const enrollments_schema_1 = require("../schemas/enrollments.schema");
const enrollments_service_1 = require("../services/enrollments.service");
let EnrollmentsController = class EnrollmentsController {
    constructor(enrollmentsService) {
        this.enrollmentsService = enrollmentsService;
    }
    async getAllEnrollments() {
        return this.enrollmentsService.getAllEnrollments();
    }
    async create(enrollment) {
        try {
            return await this.enrollmentsService.create(enrollment);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
    async edit(enrollmentId, updatedEnrollment) {
        try {
            return await this.enrollmentsService.edit(enrollmentId, updatedEnrollment);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
    async getById(enrollmentId) {
        try {
            return await this.enrollmentsService.getById(enrollmentId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.NOT_FOUND);
        }
    }
    async getByStudentId(studentId) {
        try {
            return await this.enrollmentsService.getByStudentId(studentId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getByCourseId(courseId) {
        try {
            return await this.enrollmentsService.getByCourseId(courseId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getByInstructorId(instructorId) {
        try {
            return await this.enrollmentsService.getByInstructorId(instructorId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getByStudentAndCourseId(courseId, studentId) {
        try {
            return await this.enrollmentsService.getByStudentAndCourseId(courseId, studentId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async delete(enrollmentId) {
        try {
            return await this.enrollmentsService.delete(enrollmentId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
};
__decorate([
    (0, common_1.Get)("get-all"),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/enrollments.schema").Enrollments] }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], EnrollmentsController.prototype, "getAllEnrollments", null);
__decorate([
    (0, common_1.Post)("create"),
    openapi.ApiResponse({ status: 201, type: require("../schemas/enrollments.schema").Enrollments }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [enrollments_schema_1.Enrollments]),
    __metadata("design:returntype", Promise)
], EnrollmentsController.prototype, "create", null);
__decorate([
    (0, common_1.Put)("edit/:enrollmentId"),
    openapi.ApiResponse({ status: 200, type: require("../schemas/enrollments.schema").Enrollments }),
    __param(0, (0, common_1.Param)("enrollmentId")),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, enrollments_schema_1.Enrollments]),
    __metadata("design:returntype", Promise)
], EnrollmentsController.prototype, "edit", null);
__decorate([
    (0, common_1.Get)(":enrollmentId"),
    openapi.ApiResponse({ status: 200, type: require("../schemas/enrollments.schema").Enrollments }),
    __param(0, (0, common_1.Param)("enrollmentId")),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], EnrollmentsController.prototype, "getById", null);
__decorate([
    (0, common_1.Get)("get-by-student/:studentId"),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/enrollments.schema").Enrollments] }),
    __param(0, (0, common_1.Param)("studentId")),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], EnrollmentsController.prototype, "getByStudentId", null);
__decorate([
    (0, common_1.Get)("get-by-course/:courseId"),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/enrollments.schema").Enrollments] }),
    __param(0, (0, common_1.Param)("courseId")),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], EnrollmentsController.prototype, "getByCourseId", null);
__decorate([
    (0, common_1.Get)("get-by-instructor/:instructorId"),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/enrollments.schema").Enrollments] }),
    __param(0, (0, common_1.Param)("instructorId")),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], EnrollmentsController.prototype, "getByInstructorId", null);
__decorate([
    (0, common_1.Get)("get-by-student-and-course/:courseId/:studentId"),
    openapi.ApiResponse({ status: 200, type: require("../schemas/enrollments.schema").Enrollments }),
    __param(0, (0, common_1.Param)("courseId")),
    __param(1, (0, common_1.Param)("studentId")),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String]),
    __metadata("design:returntype", Promise)
], EnrollmentsController.prototype, "getByStudentAndCourseId", null);
__decorate([
    (0, common_1.Delete)("delete/:enrollmentId"),
    openapi.ApiResponse({ status: 200 }),
    __param(0, (0, common_1.Param)("enrollmentId")),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], EnrollmentsController.prototype, "delete", null);
EnrollmentsController = __decorate([
    (0, swagger_1.ApiTags)("Enrollments"),
    (0, common_1.Controller)("enrollments"),
    __metadata("design:paramtypes", [enrollments_service_1.EnrollmentsService])
], EnrollmentsController);
exports.EnrollmentsController = EnrollmentsController;
//# sourceMappingURL=enrollments.controller.js.map