import { Payment } from 'src/schemas/payment.schema';
import { PaymentService } from 'src/services/payment.service';
export declare class PaymentController {
    private readonly paymentService;
    constructor(paymentService: PaymentService);
    create(payment: Payment): Promise<Payment>;
    edit(paymentId: string, updatedPayment: Payment): Promise<Payment>;
    getById(paymentId: string): Promise<Payment>;
    getByStudentId(studentId: string): Promise<Payment[]>;
    getByCourseId(courseId: string): Promise<Payment[]>;
    getByCourseIdAndStudentId(courseId: string, studentId: string): Promise<Payment[]>;
    getByEnrollmentsId(enrollmentsId: string): Promise<Payment[]>;
    delete(paymentId: string): Promise<void>;
}
