import { Section } from 'src/schemas/section.schema';
import { SectionService } from 'src/services/section.service';
export declare class SectionController {
    private readonly sectionService;
    constructor(sectionService: SectionService);
    create(section: Section[]): Promise<Section[]>;
    edit(sectionId: string, updatedSection: Section): Promise<Section>;
    getAll(): Promise<Section[]>;
    getById(sectionId: string): Promise<Section>;
    getByCourseId(courseId: string): Promise<Section[]>;
    getSectionByStatus(isActive: boolean): Promise<Section[]>;
    getSectionByCourseIdAndStatus(courseId: string, isActive: boolean): Promise<Section[]>;
    delete(sectionId: string): Promise<void>;
}
