"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppModule = void 0;
require("dotenv").config({ path: ".env" });
const common_1 = require("@nestjs/common");
const mongoose_1 = require("@nestjs/mongoose");
const category_schema_1 = require("../schemas/category.schema");
const user_schema_1 = require("../schemas/user.schema");
const user_controller_1 = require("../controllers/user.controller");
const user_service_1 = require("../services/user.service");
const category_controller_1 = require("../controllers/category.controller");
const category_service_1 = require("../services/category.service");
const course_schema_1 = require("../schemas/course.schema");
const course_service_1 = require("../services/course.service");
const course_controller_1 = require("../controllers/course.controller");
const section_schema_1 = require("../schemas/section.schema");
const section_controller_1 = require("../controllers/section.controller");
const section_service_1 = require("../services/section.service");
const lesson_schema_1 = require("../schemas/lesson.schema");
const lesson_controller_1 = require("../controllers/lesson.controller");
const lesson_service_1 = require("../services/lesson.service");
const question_schema_1 = require("../schemas/question.schema");
const question_controller_1 = require("../controllers/question.controller");
const question_service_1 = require("../services/question.service");
const assignment_schema_1 = require("../schemas/assignment.schema");
const assignment_controller_1 = require("../controllers/assignment.controller");
const assignment_service_1 = require("../services/assignment.service");
const feedback_schema_1 = require("../schemas/feedback.schema");
const feedback_controller_1 = require("../controllers/feedback.controller");
const feedback_service_1 = require("../services/feedback.service");
const file_module_1 = require("./file.module");
const courseDetails_controller_1 = require("../controllers/courseDetails.controller");
const courseDetails_service_1 = require("../services/courseDetails.service");
const questionMarks_schema_1 = require("../schemas/questionMarks.schema");
const questionMarks_controller_1 = require("../controllers/questionMarks.controller");
const questionMarks_service_1 = require("../services/questionMarks.service");
const enrollments_schema_1 = require("../schemas/enrollments.schema");
const courseProgress_schema_1 = require("../schemas/courseProgress.schema");
const payment_schema_1 = require("../schemas/payment.schema");
const enrollments_controller_1 = require("../controllers/enrollments.controller");
const courseProgress_controller_1 = require("../controllers/courseProgress.controller");
const payment_controller_1 = require("../controllers/payment.controller");
const enrollments_service_1 = require("../services/enrollments.service");
const courseProgress_service_1 = require("../services/courseProgress.service");
const payment_service_1 = require("../services/payment.service");
const studentCourses_schema_1 = require("../schemas/studentCourses.schema");
const studentCourses_controller_1 = require("../controllers/studentCourses.controller");
const studentCourses_service_1 = require("../services/studentCourses.service");
const cloudinary_service_1 = require("../services/cloudinary.service");
const config_1 = require("@nestjs/config");
const courseRoutine_schema_1 = require("../schemas/courseRoutine.schema");
const courseRoutine_controller_1 = require("../controllers/courseRoutine.controller");
const courseRoutine_service_1 = require("../services/courseRoutine.service");
const mongo_uri = process.env.DATABASE_URL;
let AppModule = class AppModule {
};
AppModule = __decorate([
    (0, common_1.Module)({
        imports: [
            mongoose_1.MongooseModule.forRoot(mongo_uri),
            config_1.ConfigModule.forRoot({
                isGlobal: true,
            }),
            mongoose_1.MongooseModule.forFeature([
                { name: "User", schema: user_schema_1.UserSchema },
                { name: "Category", schema: category_schema_1.CategorySchema },
                { name: "Course", schema: course_schema_1.CourseSchema },
                { name: "Section", schema: section_schema_1.SectionSchema },
                { name: "Lesson", schema: lesson_schema_1.LessonSchema },
                { name: "Question", schema: question_schema_1.QuestionSchema },
                { name: "Assignment", schema: assignment_schema_1.AssignmentSchema },
                { name: "Feedback", schema: feedback_schema_1.FeedbackSchema },
                { name: "QuestionMarks", schema: questionMarks_schema_1.QuestionMarksSchema },
                { name: "Enrollments", schema: enrollments_schema_1.EnrollmentsSchema },
                { name: "CourseProgress", schema: courseProgress_schema_1.CourseProgressSchema },
                { name: "Payment", schema: payment_schema_1.PaymentSchema },
                { name: "StudentCourses", schema: studentCourses_schema_1.StudentCoursesSchema },
                { name: "CourseRoutine", schema: courseRoutine_schema_1.CourseRoutineSchema },
            ]),
            file_module_1.UploadModule,
        ],
        controllers: [
            user_controller_1.UserController,
            category_controller_1.CategoryController,
            course_controller_1.CourseController,
            section_controller_1.SectionController,
            lesson_controller_1.LessonController,
            question_controller_1.QuestionController,
            assignment_controller_1.AssignmentController,
            feedback_controller_1.FeedbackController,
            courseDetails_controller_1.CourseDetailsController,
            questionMarks_controller_1.QuestionMarksController,
            enrollments_controller_1.EnrollmentsController,
            courseProgress_controller_1.CourseProgressController,
            payment_controller_1.PaymentController,
            studentCourses_controller_1.StudentCoursesController,
            courseRoutine_controller_1.CourseRoutineController,
        ],
        providers: [
            user_service_1.UserService,
            category_service_1.CategoryService,
            course_service_1.CourseService,
            section_service_1.SectionService,
            lesson_service_1.LessonService,
            question_service_1.QuestionService,
            assignment_service_1.AssignmentService,
            feedback_service_1.FeedbackService,
            courseDetails_service_1.CourseDetailsService,
            questionMarks_service_1.QuestionMarksService,
            enrollments_service_1.EnrollmentsService,
            courseProgress_service_1.CourseProgressService,
            payment_service_1.PaymentService,
            studentCourses_service_1.StudentCoursesService,
            cloudinary_service_1.CloudinaryService,
            config_1.ConfigService,
            courseRoutine_service_1.CourseRoutineService,
        ],
    })
], AppModule);
exports.AppModule = AppModule;
//# sourceMappingURL=app.module.js.map