import mongoose, { HydratedDocument } from "mongoose";
import { Section } from "./section.schema";
export type LessonDocument = HydratedDocument<Lesson>;
export declare class Lesson {
    name: string;
    sectionId: Section;
    sectionName: string;
    lessonURL: string;
    thumbnail: string;
    duration: string;
    isFree: boolean;
    positions: number;
    markPerQuestion: number;
    isModelTest: boolean;
    passingMarks: number;
    examTime: number;
    isNegativeMarks: boolean;
    negativeMarks: number;
    isActive: boolean;
    info: string;
    createdAt: Date;
    updatedAt: Date;
}
export declare const LessonSchema: mongoose.Schema<Lesson, mongoose.Model<Lesson, any, any, any, mongoose.Document<unknown, any, Lesson> & Lesson & {
    _id: mongoose.Types.ObjectId;
}, any>, {}, {}, {}, {}, mongoose.DefaultSchemaOptions, Lesson, mongoose.Document<unknown, {}, mongoose.FlatRecord<Lesson>> & mongoose.FlatRecord<Lesson> & {
    _id: mongoose.Types.ObjectId;
}>;
