import mongoose, { HydratedDocument } from "mongoose";
import { User } from "./user.schema";
import { Lesson } from "./lesson.schema";
import { Course } from "./course.schema";
import { Assignment } from "./assignment.schema";
export type QuestionMarksDocument = HydratedDocument<QuestionMarks>;
export declare class QuestionMarks {
    totalQuestion: number;
    mark: number;
    totalMark: number;
    negativeMark: number;
    totalWrong: number;
    totalCorrect: number;
    isPassed: Boolean;
    questionType: string;
    studentId: User;
    studentName: string;
    lessonId: Lesson;
    lessonName: string;
    courseId: Course;
    courseName: string;
    assignmentId: Assignment;
    assignmentFile: string;
    createdAt: Date;
    updatedAt: Date;
}
export declare const QuestionMarksSchema: mongoose.Schema<QuestionMarks, mongoose.Model<QuestionMarks, any, any, any, mongoose.Document<unknown, any, QuestionMarks> & QuestionMarks & {
    _id: mongoose.Types.ObjectId;
}, any>, {}, {}, {}, {}, mongoose.DefaultSchemaOptions, QuestionMarks, mongoose.Document<unknown, {}, mongoose.FlatRecord<QuestionMarks>> & mongoose.FlatRecord<QuestionMarks> & {
    _id: mongoose.Types.ObjectId;
}>;
