"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.QuestionMarksSchema = exports.QuestionMarks = void 0;
const mongoose_1 = require("@nestjs/mongoose");
const mongoose_2 = require("mongoose");
const user_schema_1 = require("./user.schema");
const lesson_schema_1 = require("./lesson.schema");
const course_schema_1 = require("./course.schema");
const assignment_schema_1 = require("./assignment.schema");
let QuestionMarks = class QuestionMarks {
};
__decorate([
    (0, mongoose_1.Prop)({ required: false }),
    __metadata("design:type", Number)
], QuestionMarks.prototype, "totalQuestion", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: true }),
    __metadata("design:type", Number)
], QuestionMarks.prototype, "mark", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: true }),
    __metadata("design:type", Number)
], QuestionMarks.prototype, "totalMark", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: false }),
    __metadata("design:type", Number)
], QuestionMarks.prototype, "negativeMark", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: false }),
    __metadata("design:type", Number)
], QuestionMarks.prototype, "totalWrong", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: false }),
    __metadata("design:type", Number)
], QuestionMarks.prototype, "totalCorrect", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: false }),
    __metadata("design:type", Boolean)
], QuestionMarks.prototype, "isPassed", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: true, enum: ["ASSIGNMENT", "QUIZ"] }),
    __metadata("design:type", String)
], QuestionMarks.prototype, "questionType", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: mongoose_2.default.Schema.Types.ObjectId, ref: "User", required: true }),
    __metadata("design:type", user_schema_1.User)
], QuestionMarks.prototype, "studentId", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: true }),
    __metadata("design:type", String)
], QuestionMarks.prototype, "studentName", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: mongoose_2.default.Schema.Types.ObjectId, ref: "Lesson", required: true }),
    __metadata("design:type", lesson_schema_1.Lesson)
], QuestionMarks.prototype, "lessonId", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: true }),
    __metadata("design:type", String)
], QuestionMarks.prototype, "lessonName", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: mongoose_2.default.Schema.Types.ObjectId, ref: "Course", required: true }),
    __metadata("design:type", course_schema_1.Course)
], QuestionMarks.prototype, "courseId", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: false }),
    __metadata("design:type", String)
], QuestionMarks.prototype, "courseName", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: mongoose_2.default.Schema.Types.ObjectId, ref: "Assignment", required: false }),
    __metadata("design:type", assignment_schema_1.Assignment)
], QuestionMarks.prototype, "assignmentId", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: false }),
    __metadata("design:type", String)
], QuestionMarks.prototype, "assignmentFile", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: true, default: (0, mongoose_2.now)() }),
    __metadata("design:type", Date)
], QuestionMarks.prototype, "createdAt", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: false, default: (0, mongoose_2.now)() }),
    __metadata("design:type", Date)
], QuestionMarks.prototype, "updatedAt", void 0);
QuestionMarks = __decorate([
    (0, mongoose_1.Schema)({ timestamps: true })
], QuestionMarks);
exports.QuestionMarks = QuestionMarks;
exports.QuestionMarksSchema = mongoose_1.SchemaFactory.createForClass(QuestionMarks);
//# sourceMappingURL=questionMarks.schema.js.map