"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CourseProgressService = void 0;
const common_1 = require("@nestjs/common");
const mongoose_1 = require("@nestjs/mongoose");
const mongoose_2 = require("mongoose");
const courseProgress_schema_1 = require("../schemas/courseProgress.schema");
let CourseProgressService = class CourseProgressService {
    constructor(courseProgressModel) {
        this.courseProgressModel = courseProgressModel;
    }
    async create(courseProgress) {
        const createdCourseProgress = new this.courseProgressModel(courseProgress);
        return createdCourseProgress.save();
    }
    async edit(courseProgressId, updatedCourseProgress) {
        const existingCourseProgress = await this.courseProgressModel
            .findByIdAndUpdate(courseProgressId, updatedCourseProgress, { new: true })
            .exec();
        if (!existingCourseProgress) {
            throw new common_1.NotFoundException(`CourseProgress with ID ${courseProgressId} not found`);
        }
        return existingCourseProgress;
    }
    async getById(courseProgressId) {
        const courseProgress = await this.courseProgressModel.findById(courseProgressId).exec();
        if (!courseProgress) {
            throw new common_1.NotFoundException(`CourseProgress with ID ${courseProgressId} not found`);
        }
        return courseProgress;
    }
    async getByStudentId(studentId) {
        return this.courseProgressModel.find({ studentId }).exec();
    }
    async getByCourseId(courseId) {
        return this.courseProgressModel.find({ courseId }).exec();
    }
    async getByLessonId(lessonId) {
        return this.courseProgressModel.find({ lessonId }).exec();
    }
    async delete(courseProgressId) {
        await this.getById(courseProgressId);
        await this.courseProgressModel.findByIdAndDelete(courseProgressId).exec();
    }
};
CourseProgressService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(courseProgress_schema_1.CourseProgress.name)),
    __metadata("design:paramtypes", [mongoose_2.Model])
], CourseProgressService);
exports.CourseProgressService = CourseProgressService;
//# sourceMappingURL=courseProgress.service.js.map