import { Model } from 'mongoose';
import { Feedback, FeedbackDocument } from 'src/schemas/feedback.schema';
export declare class FeedbackService {
    private feedbackModel;
    constructor(feedbackModel: Model<FeedbackDocument>);
    create(feedback: Feedback): Promise<Feedback>;
    edit(feedbackId: string, updatedFeedback: Feedback): Promise<Feedback>;
    getAll(): Promise<Feedback[]>;
    getFeedbackByStatus(status: boolean): Promise<Feedback[]>;
    getById(feedbackId: string): Promise<Feedback>;
    getByUserId(userId: string): Promise<Feedback[]>;
    getByCourseId(courseId: string): Promise<Feedback[]>;
    delete(feedbackId: string): Promise<void>;
}
