import { Model } from 'mongoose';
import { Question, QuestionDocument } from 'src/schemas/question.schema';
export declare class QuestionService {
    private questionModel;
    constructor(questionModel: Model<QuestionDocument>);
    create(questions: Question[]): Promise<Question[]>;
    edit(questions: {
        questionId: string;
        updatedQuestion: Question;
    }[]): Promise<Question[]>;
    getAll(): Promise<Question[]>;
    getById(questionId: string): Promise<Question>;
    getByLessonId(lessonId: string): Promise<Question[]>;
    delete(questionId: string): Promise<void>;
    deleteByLessonId(lessonId: string): Promise<void>;
    checkQuestionTextNotExists(text: string, lessonId: any, excludedQuestionId?: string): Promise<void>;
}
