"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StudentCoursesService = void 0;
const common_1 = require("@nestjs/common");
const mongoose_1 = require("@nestjs/mongoose");
const mongoose_2 = require("mongoose");
const studentCourses_schema_1 = require("../schemas/studentCourses.schema");
let StudentCoursesService = class StudentCoursesService {
    constructor(studentCoursesModel) {
        this.studentCoursesModel = studentCoursesModel;
    }
    async create(studentCourses) {
        const createdStudentCourses = new this.studentCoursesModel(studentCourses);
        return createdStudentCourses.save();
    }
    async edit(updatedStudentCourses) {
        const { courseId, studentId } = updatedStudentCourses;
        const existingStudentCourses = await this.studentCoursesModel
            .findOneAndUpdate({ courseId, studentId }, updatedStudentCourses, {
            new: true,
        })
            .exec();
        if (!existingStudentCourses) {
            throw new common_1.NotFoundException(`StudentCourses with courseId ${courseId} and studentId ${studentId} not found`);
        }
        return existingStudentCourses;
    }
    async getByStudentId(studentId) {
        return this.studentCoursesModel.find({ studentId }).exec();
    }
    async getByCourseId(courseId) {
        return this.studentCoursesModel.find({ courseId }).exec();
    }
    async deleteByEnrollmentId(enrollmentId) {
        await this.studentCoursesModel
            .deleteMany({ enrollmentsId: enrollmentId })
            .exec();
    }
};
StudentCoursesService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(studentCourses_schema_1.StudentCourses.name)),
    __metadata("design:paramtypes", [mongoose_2.Model])
], StudentCoursesService);
exports.StudentCoursesService = StudentCoursesService;
//# sourceMappingURL=studentCourses.service.js.map